// Marcus Brand

#if defined(WINDOWS)
#include <winsock2.h>
#else
// 2 Includes fr socket()
#include <sys/types.h>
#include <sys/socket.h>
// 2 Includes fr inet_addr()
#include <netinet/in.h>
#include <arpa/inet.h>
// 2 Includes fr fcntl()
#include <unistd.h>
#include <fcntl.h>
// fr memset()
#define INVALID_SOCKET -1
#define WSAGetLastError() errno
#endif

#include "player.h"

void Player::InitShotMap()
{
	m_ShotMap[0].m_Ship_LookX = 1536;
	m_ShotMap[0].m_Ship_LookY = 0;
	m_ShotMap[0].m_xFirst = 19;
	m_ShotMap[0].m_yFirst = 0;
	m_ShotMap[0].m_dDX = 7.875000;
	m_ShotMap[0].m_dDY = 0.000000;

	m_ShotMap[1].m_Ship_LookX = 1536;
	m_ShotMap[1].m_Ship_LookY = 0;
	m_ShotMap[1].m_xFirst = 19;
	m_ShotMap[1].m_yFirst = -2;
	m_ShotMap[1].m_dDX = 7.875000;
	m_ShotMap[1].m_dDY = -0.625000;

	m_ShotMap[2].m_Ship_LookX = 1528;
	m_ShotMap[2].m_Ship_LookY = -152;
	m_ShotMap[2].m_xFirst = 19;
	m_ShotMap[2].m_yFirst = -4;
	m_ShotMap[2].m_dDX = 7.875000;
	m_ShotMap[2].m_dDY = -1.250000;

	m_ShotMap[3].m_Ship_LookX = 1504;
	m_ShotMap[3].m_Ship_LookY = -296;
	m_ShotMap[3].m_xFirst = 19;
	m_ShotMap[3].m_yFirst = -5;
	m_ShotMap[3].m_dDX = 7.750000;
	m_ShotMap[3].m_dDY = -1.750000;

	m_ShotMap[4].m_Ship_LookX = 1472;
	m_ShotMap[4].m_Ship_LookY = -440;
	m_ShotMap[4].m_xFirst = 19;
	m_ShotMap[4].m_yFirst = -6;
	m_ShotMap[4].m_dDX = 7.625000;
	m_ShotMap[4].m_dDY = -2.375000;

	m_ShotMap[5].m_Ship_LookX = 1472;
	m_ShotMap[5].m_Ship_LookY = -440;
	m_ShotMap[5].m_xFirst = 18;
	m_ShotMap[5].m_yFirst = -8;
	m_ShotMap[5].m_dDX = 7.375000;
	m_ShotMap[5].m_dDY = -2.875000;

	m_ShotMap[6].m_Ship_LookX = 1416;
	m_ShotMap[6].m_Ship_LookY = -584;
	m_ShotMap[6].m_xFirst = 17;
	m_ShotMap[6].m_yFirst = -9;
	m_ShotMap[6].m_dDX = 7.125000;
	m_ShotMap[6].m_dDY = -3.375000;

	m_ShotMap[7].m_Ship_LookX = 1360;
	m_ShotMap[7].m_Ship_LookY = -720;
	m_ShotMap[7].m_xFirst = 17;
	m_ShotMap[7].m_yFirst = -10;
	m_ShotMap[7].m_dDX = 6.875000;
	m_ShotMap[7].m_dDY = -4.000000;

	m_ShotMap[8].m_Ship_LookX = 1280;
	m_ShotMap[8].m_Ship_LookY = -856;
	m_ShotMap[8].m_xFirst = 16;
	m_ShotMap[8].m_yFirst = -12;
	m_ShotMap[8].m_dDX = 6.625000;
	m_ShotMap[8].m_dDY = -4.500000;

	m_ShotMap[9].m_Ship_LookX = 1280;
	m_ShotMap[9].m_Ship_LookY = -856;
	m_ShotMap[9].m_xFirst = 15;
	m_ShotMap[9].m_yFirst = -13;
	m_ShotMap[9].m_dDX = 6.250000;
	m_ShotMap[9].m_dDY = -4.875000;

	m_ShotMap[10].m_Ship_LookX = 1192;
	m_ShotMap[10].m_Ship_LookY = -976;
	m_ShotMap[10].m_xFirst = 14;
	m_ShotMap[10].m_yFirst = -14;
	m_ShotMap[10].m_dDX = 5.875000;
	m_ShotMap[10].m_dDY = -5.375000;

	m_ShotMap[11].m_Ship_LookX = 1088;
	m_ShotMap[11].m_Ship_LookY = -1088;
	m_ShotMap[11].m_xFirst = 13;
	m_ShotMap[11].m_yFirst = -15;
	m_ShotMap[11].m_dDX = 5.500000;
	m_ShotMap[11].m_dDY = -5.750000;

	m_ShotMap[12].m_Ship_LookX = 976;
	m_ShotMap[12].m_Ship_LookY = -1192;
	m_ShotMap[12].m_xFirst = 12;
	m_ShotMap[12].m_yFirst = -16;
	m_ShotMap[12].m_dDX = 5.000000;
	m_ShotMap[12].m_dDY = -6.125000;

	m_ShotMap[13].m_Ship_LookX = 976;
	m_ShotMap[13].m_Ship_LookY = -1192;
	m_ShotMap[13].m_xFirst = 11;
	m_ShotMap[13].m_yFirst = -17;
	m_ShotMap[13].m_dDX = 4.500000;
	m_ShotMap[13].m_dDY = -6.500000;

	m_ShotMap[14].m_Ship_LookX = 856;
	m_ShotMap[14].m_Ship_LookY = -1280;
	m_ShotMap[14].m_xFirst = 10;
	m_ShotMap[14].m_yFirst = -18;
	m_ShotMap[14].m_dDX = 4.000000;
	m_ShotMap[14].m_dDY = -6.875000;

	m_ShotMap[15].m_Ship_LookX = 720;
	m_ShotMap[15].m_Ship_LookY = -1360;
	m_ShotMap[15].m_xFirst = 8;
	m_ShotMap[15].m_yFirst = -18;
	m_ShotMap[15].m_dDX = 3.500000;
	m_ShotMap[15].m_dDY = -7.125000;

	m_ShotMap[16].m_Ship_LookX = 584;
	m_ShotMap[16].m_Ship_LookY = -1416;
	m_ShotMap[16].m_xFirst = 7;
	m_ShotMap[16].m_yFirst = -19;
	m_ShotMap[16].m_dDX = 3.000000;
	m_ShotMap[16].m_dDY = -7.375000;

	m_ShotMap[17].m_Ship_LookX = 584;
	m_ShotMap[17].m_Ship_LookY = -1416;
	m_ShotMap[17].m_xFirst = 6;
	m_ShotMap[17].m_yFirst = -20;
	m_ShotMap[17].m_dDX = 2.500000;
	m_ShotMap[17].m_dDY = -7.625000;

	m_ShotMap[18].m_Ship_LookX = 440;
	m_ShotMap[18].m_Ship_LookY = -1472;
	m_ShotMap[18].m_xFirst = 4;
	m_ShotMap[18].m_yFirst = -20;
	m_ShotMap[18].m_dDX = 1.875000;
	m_ShotMap[18].m_dDY = -7.750000;

	m_ShotMap[19].m_Ship_LookX = 296;
	m_ShotMap[19].m_Ship_LookY = -1504;
	m_ShotMap[19].m_xFirst = 3;
	m_ShotMap[19].m_yFirst = -20;
	m_ShotMap[19].m_dDX = 1.375000;
	m_ShotMap[19].m_dDY = -7.875000;

	m_ShotMap[20].m_Ship_LookX = 152;
	m_ShotMap[20].m_Ship_LookY = -1528;
	m_ShotMap[20].m_xFirst = 1;
	m_ShotMap[20].m_yFirst = -20;
	m_ShotMap[20].m_dDX = 0.750000;
	m_ShotMap[20].m_dDY = -7.875000;

	m_ShotMap[21].m_Ship_LookX = 152;
	m_ShotMap[21].m_Ship_LookY = -1528;
	m_ShotMap[21].m_xFirst = 0;
	m_ShotMap[21].m_yFirst = -20;
	m_ShotMap[21].m_dDX = 0.125000;
	m_ShotMap[21].m_dDY = -8.000000;

	m_ShotMap[22].m_Ship_LookX = -152;
	m_ShotMap[22].m_Ship_LookY = -1528;
	m_ShotMap[22].m_xFirst = -1;
	m_ShotMap[22].m_yFirst = -20;
	m_ShotMap[22].m_dDX = -0.375000;
	m_ShotMap[22].m_dDY = -8.000000;

	m_ShotMap[23].m_Ship_LookX = -296;
	m_ShotMap[23].m_Ship_LookY = -1504;
	m_ShotMap[23].m_xFirst = -3;
	m_ShotMap[23].m_yFirst = -20;
	m_ShotMap[23].m_dDX = -1.000000;
	m_ShotMap[23].m_dDY = -7.875000;

	m_ShotMap[24].m_Ship_LookX = -296;
	m_ShotMap[24].m_Ship_LookY = -1504;
	m_ShotMap[24].m_xFirst = -5;
	m_ShotMap[24].m_yFirst = -20;
	m_ShotMap[24].m_dDX = -1.625000;
	m_ShotMap[24].m_dDY = -7.875000;

	m_ShotMap[25].m_Ship_LookX = -440;
	m_ShotMap[25].m_Ship_LookY = -1472;
	m_ShotMap[25].m_xFirst = -6;
	m_ShotMap[25].m_yFirst = -20;
	m_ShotMap[25].m_dDX = -2.125000;
	m_ShotMap[25].m_dDY = -7.625000;

	m_ShotMap[26].m_Ship_LookX = -584;
	m_ShotMap[26].m_Ship_LookY = -1416;
	m_ShotMap[26].m_xFirst = -7;
	m_ShotMap[26].m_yFirst = -19;
	m_ShotMap[26].m_dDX = -2.750000;
	m_ShotMap[26].m_dDY = -7.500000;

	m_ShotMap[27].m_Ship_LookX = -720;
	m_ShotMap[27].m_Ship_LookY = -1360;
	m_ShotMap[27].m_xFirst = -9;
	m_ShotMap[27].m_yFirst = -19;
	m_ShotMap[27].m_dDX = -3.250000;
	m_ShotMap[27].m_dDY = -7.250000;

	m_ShotMap[28].m_Ship_LookX = -720;
	m_ShotMap[28].m_Ship_LookY = -1360;
	m_ShotMap[28].m_xFirst = -10;
	m_ShotMap[28].m_yFirst = -18;
	m_ShotMap[28].m_dDX = -3.750000;
	m_ShotMap[28].m_dDY = -7.000000;

	m_ShotMap[29].m_Ship_LookX = -856;
	m_ShotMap[29].m_Ship_LookY = -1280;
	m_ShotMap[29].m_xFirst = -11;
	m_ShotMap[29].m_yFirst = -17;
	m_ShotMap[29].m_dDX = -4.250000;
	m_ShotMap[29].m_dDY = -6.750000;

	m_ShotMap[30].m_Ship_LookX = -976;
	m_ShotMap[30].m_Ship_LookY = -1192;
	m_ShotMap[30].m_xFirst = -12;
	m_ShotMap[30].m_yFirst = -16;
	m_ShotMap[30].m_dDX = -4.750000;
	m_ShotMap[30].m_dDY = -6.375000;

	m_ShotMap[31].m_Ship_LookX = -1088;
	m_ShotMap[31].m_Ship_LookY = -1088;
	m_ShotMap[31].m_xFirst = -14;
	m_ShotMap[31].m_yFirst = -15;
	m_ShotMap[31].m_dDX = -5.250000;
	m_ShotMap[31].m_dDY = -6.000000;

	m_ShotMap[32].m_Ship_LookX = -1088;
	m_ShotMap[32].m_Ship_LookY = -1088;
	m_ShotMap[32].m_xFirst = -15;
	m_ShotMap[32].m_yFirst = -15;
	m_ShotMap[32].m_dDX = -5.625000;
	m_ShotMap[32].m_dDY = -5.625000;

	m_ShotMap[33].m_Ship_LookX = -1192;
	m_ShotMap[33].m_Ship_LookY = -976;
	m_ShotMap[33].m_xFirst = -15;
	m_ShotMap[33].m_yFirst = -14;
	m_ShotMap[33].m_dDX = -6.000000;
	m_ShotMap[33].m_dDY = -5.250000;

	m_ShotMap[34].m_Ship_LookX = -1280;
	m_ShotMap[34].m_Ship_LookY = -856;
	m_ShotMap[34].m_xFirst = -16;
	m_ShotMap[34].m_yFirst = -12;
	m_ShotMap[34].m_dDX = -6.375000;
	m_ShotMap[34].m_dDY = -4.750000;

	m_ShotMap[35].m_Ship_LookX = -1360;
	m_ShotMap[35].m_Ship_LookY = -720;
	m_ShotMap[35].m_xFirst = -17;
	m_ShotMap[35].m_yFirst = -11;
	m_ShotMap[35].m_dDX = -6.750000;
	m_ShotMap[35].m_dDY = -4.250000;

	m_ShotMap[36].m_Ship_LookX = -1360;
	m_ShotMap[36].m_Ship_LookY = -720;
	m_ShotMap[36].m_xFirst = -18;
	m_ShotMap[36].m_yFirst = -10;
	m_ShotMap[36].m_dDX = -7.000000;
	m_ShotMap[36].m_dDY = -3.750000;

	m_ShotMap[37].m_Ship_LookX = -1416;
	m_ShotMap[37].m_Ship_LookY = -584;
	m_ShotMap[37].m_xFirst = -19;
	m_ShotMap[37].m_yFirst = -9;
	m_ShotMap[37].m_dDX = -7.250000;
	m_ShotMap[37].m_dDY = -3.250000;

	m_ShotMap[38].m_Ship_LookX = -1472;
	m_ShotMap[38].m_Ship_LookY = -440;
	m_ShotMap[38].m_xFirst = -19;
	m_ShotMap[38].m_yFirst = -7;
	m_ShotMap[38].m_dDX = -7.500000;
	m_ShotMap[38].m_dDY = -2.750000;

	m_ShotMap[39].m_Ship_LookX = -1504;
	m_ShotMap[39].m_Ship_LookY = -296;
	m_ShotMap[39].m_xFirst = -20;
	m_ShotMap[39].m_yFirst = -6;
	m_ShotMap[39].m_dDX = -7.625000;
	m_ShotMap[39].m_dDY = -2.125000;

	m_ShotMap[40].m_Ship_LookX = -1504;
	m_ShotMap[40].m_Ship_LookY = -296;
	m_ShotMap[40].m_xFirst = -20;
	m_ShotMap[40].m_yFirst = -5;
	m_ShotMap[40].m_dDX = -7.875000;
	m_ShotMap[40].m_dDY = -1.625000;

	m_ShotMap[41].m_Ship_LookX = -1528;
	m_ShotMap[41].m_Ship_LookY = -152;
	m_ShotMap[41].m_xFirst = -20;
	m_ShotMap[41].m_yFirst = -3;
	m_ShotMap[41].m_dDX = -7.875000;
	m_ShotMap[41].m_dDY = -1.000000;

	m_ShotMap[42].m_Ship_LookX = -1536;
	m_ShotMap[42].m_Ship_LookY = 0;
	m_ShotMap[42].m_xFirst = -20;
	m_ShotMap[42].m_yFirst = -1;
	m_ShotMap[42].m_dDX = -8.000000;
	m_ShotMap[42].m_dDY = -0.375000;

	m_ShotMap[43].m_Ship_LookX = -1536;
	m_ShotMap[43].m_Ship_LookY = 0;
	m_ShotMap[43].m_xFirst = -20;
	m_ShotMap[43].m_yFirst = 0;
	m_ShotMap[43].m_dDX = -8.000000;
	m_ShotMap[43].m_dDY = 0.125000;

	m_ShotMap[44].m_Ship_LookX = -1528;
	m_ShotMap[44].m_Ship_LookY = 152;
	m_ShotMap[44].m_xFirst = -20;
	m_ShotMap[44].m_yFirst = 1;
	m_ShotMap[44].m_dDX = -7.875000;
	m_ShotMap[44].m_dDY = 0.750000;

	m_ShotMap[45].m_Ship_LookX = -1528;
	m_ShotMap[45].m_Ship_LookY = 152;
	m_ShotMap[45].m_xFirst = -20;
	m_ShotMap[45].m_yFirst = 3;
	m_ShotMap[45].m_dDX = -7.875000;
	m_ShotMap[45].m_dDY = 1.375000;

	m_ShotMap[46].m_Ship_LookX = -1504;
	m_ShotMap[46].m_Ship_LookY = 296;
	m_ShotMap[46].m_xFirst = -20;
	m_ShotMap[46].m_yFirst = 4;
	m_ShotMap[46].m_dDX = -7.750000;
	m_ShotMap[46].m_dDY = 1.875000;

	m_ShotMap[47].m_Ship_LookX = -1472;
	m_ShotMap[47].m_Ship_LookY = 440;
	m_ShotMap[47].m_xFirst = -20;
	m_ShotMap[47].m_yFirst = 6;
	m_ShotMap[47].m_dDX = -7.625000;
	m_ShotMap[47].m_dDY = 2.500000;

	m_ShotMap[48].m_Ship_LookX = -1416;
	m_ShotMap[48].m_Ship_LookY = 584;
	m_ShotMap[48].m_xFirst = -19;
	m_ShotMap[48].m_yFirst = 7;
	m_ShotMap[48].m_dDX = -7.375000;
	m_ShotMap[48].m_dDY = 3.000000;

	m_ShotMap[49].m_Ship_LookX = -1416;
	m_ShotMap[49].m_Ship_LookY = 584;
	m_ShotMap[49].m_xFirst = -18;
	m_ShotMap[49].m_yFirst = 8;
	m_ShotMap[49].m_dDX = -7.125000;
	m_ShotMap[49].m_dDY = 3.500000;

	m_ShotMap[50].m_Ship_LookX = -1360;
	m_ShotMap[50].m_Ship_LookY = 720;
	m_ShotMap[50].m_xFirst = -18;
	m_ShotMap[50].m_yFirst = 10;
	m_ShotMap[50].m_dDX = -6.875000;
	m_ShotMap[50].m_dDY = 4.000000;

	m_ShotMap[51].m_Ship_LookX = -1280;
	m_ShotMap[51].m_Ship_LookY = 856;
	m_ShotMap[51].m_xFirst = -17;
	m_ShotMap[51].m_yFirst = 11;
	m_ShotMap[51].m_dDX = -6.500000;
	m_ShotMap[51].m_dDY = 4.500000;

	m_ShotMap[52].m_Ship_LookX = -1192;
	m_ShotMap[52].m_Ship_LookY = 976;
	m_ShotMap[52].m_xFirst = -16;
	m_ShotMap[52].m_yFirst = 12;
	m_ShotMap[52].m_dDX = -6.125000;
	m_ShotMap[52].m_dDY = 5.000000;

	m_ShotMap[53].m_Ship_LookX = -1192;
	m_ShotMap[53].m_Ship_LookY = 976;
	m_ShotMap[53].m_xFirst = -15;
	m_ShotMap[53].m_yFirst = 13;
	m_ShotMap[53].m_dDX = -5.750000;
	m_ShotMap[53].m_dDY = 5.500000;

	m_ShotMap[54].m_Ship_LookX = -1088;
	m_ShotMap[54].m_Ship_LookY = 1088;
	m_ShotMap[54].m_xFirst = -14;
	m_ShotMap[54].m_yFirst = 14;
	m_ShotMap[54].m_dDX = -5.375000;
	m_ShotMap[54].m_dDY = 5.875000;

	m_ShotMap[55].m_Ship_LookX = -976;
	m_ShotMap[55].m_Ship_LookY = 1192;
	m_ShotMap[55].m_xFirst = -13;
	m_ShotMap[55].m_yFirst = 15;
	m_ShotMap[55].m_dDX = -4.875000;
	m_ShotMap[55].m_dDY = 6.250000;

	m_ShotMap[56].m_Ship_LookX = -856;
	m_ShotMap[56].m_Ship_LookY = 1280;
	m_ShotMap[56].m_xFirst = -12;
	m_ShotMap[56].m_yFirst = 16;
	m_ShotMap[56].m_dDX = -4.500000;
	m_ShotMap[56].m_dDY = 6.625000;

	m_ShotMap[57].m_Ship_LookX = -856;
	m_ShotMap[57].m_Ship_LookY = 1280;
	m_ShotMap[57].m_xFirst = -10;
	m_ShotMap[57].m_yFirst = 17;
	m_ShotMap[57].m_dDX = -4.000000;
	m_ShotMap[57].m_dDY = 6.875000;

	m_ShotMap[58].m_Ship_LookX = -720;
	m_ShotMap[58].m_Ship_LookY = 1360;
	m_ShotMap[58].m_xFirst = -9;
	m_ShotMap[58].m_yFirst = 17;
	m_ShotMap[58].m_dDX = -3.375000;
	m_ShotMap[58].m_dDY = 7.125000;

	m_ShotMap[59].m_Ship_LookX = -584;
	m_ShotMap[59].m_Ship_LookY = 1416;
	m_ShotMap[59].m_xFirst = -8;
	m_ShotMap[59].m_yFirst = 18;
	m_ShotMap[59].m_dDX = -2.875000;
	m_ShotMap[59].m_dDY = 7.375000;

	m_ShotMap[60].m_Ship_LookX = -440;
	m_ShotMap[60].m_Ship_LookY = 1472;
	m_ShotMap[60].m_xFirst = -6;
	m_ShotMap[60].m_yFirst = 19;
	m_ShotMap[60].m_dDX = -2.375000;
	m_ShotMap[60].m_dDY = 7.625000;

	m_ShotMap[61].m_Ship_LookX = -440;
	m_ShotMap[61].m_Ship_LookY = 1472;
	m_ShotMap[61].m_xFirst = -5;
	m_ShotMap[61].m_yFirst = 19;
	m_ShotMap[61].m_dDX = -1.750000;
	m_ShotMap[61].m_dDY = 7.750000;

	m_ShotMap[62].m_Ship_LookX = -296;
	m_ShotMap[62].m_Ship_LookY = 1504;
	m_ShotMap[62].m_xFirst = -4;
	m_ShotMap[62].m_yFirst = 19;
	m_ShotMap[62].m_dDX = -1.250000;
	m_ShotMap[62].m_dDY = 7.875000;

	m_ShotMap[63].m_Ship_LookX = -152;
	m_ShotMap[63].m_Ship_LookY = 1528;
	m_ShotMap[63].m_xFirst = -2;
	m_ShotMap[63].m_yFirst = 19;
	m_ShotMap[63].m_dDX = -0.625000;
	m_ShotMap[63].m_dDY = 7.875000;

	m_ShotMap[64].m_Ship_LookX = 0;
	m_ShotMap[64].m_Ship_LookY = 1536;
	m_ShotMap[64].m_xFirst = 0;
	m_ShotMap[64].m_yFirst = 19;
	m_ShotMap[64].m_dDX = 0.000000;
	m_ShotMap[64].m_dDY = 7.875000;

	m_ShotMap[65].m_Ship_LookX = 152;
	m_ShotMap[65].m_Ship_LookY = 1528;
	m_ShotMap[65].m_xFirst = 1;
	m_ShotMap[65].m_yFirst = 19;
	m_ShotMap[65].m_dDX = 0.500000;
	m_ShotMap[65].m_dDY = 7.875000;

	m_ShotMap[66].m_Ship_LookX = 296;
	m_ShotMap[66].m_Ship_LookY = 1504;
	m_ShotMap[66].m_xFirst = 2;
	m_ShotMap[66].m_yFirst = 19;
	m_ShotMap[66].m_dDX = 1.125000;
	m_ShotMap[66].m_dDY = 7.875000;

	m_ShotMap[67].m_Ship_LookX = 440;
	m_ShotMap[67].m_Ship_LookY = 1472;
	m_ShotMap[67].m_xFirst = 4;
	m_ShotMap[67].m_yFirst = 19;
	m_ShotMap[67].m_dDX = 1.750000;
	m_ShotMap[67].m_dDY = 7.750000;

	m_ShotMap[68].m_Ship_LookX = 440;
	m_ShotMap[68].m_Ship_LookY = 1472;
	m_ShotMap[68].m_xFirst = 5;
	m_ShotMap[68].m_yFirst = 19;
	m_ShotMap[68].m_dDX = 2.250000;
	m_ShotMap[68].m_dDY = 7.625000;

	m_ShotMap[69].m_Ship_LookX = 584;
	m_ShotMap[69].m_Ship_LookY = 1416;
	m_ShotMap[69].m_xFirst = 7;
	m_ShotMap[69].m_yFirst = 18;
	m_ShotMap[69].m_dDX = 2.875000;
	m_ShotMap[69].m_dDY = 7.375000;

	m_ShotMap[70].m_Ship_LookX = 720;
	m_ShotMap[70].m_Ship_LookY = 1360;
	m_ShotMap[70].m_xFirst = 8;
	m_ShotMap[70].m_yFirst = 17;
	m_ShotMap[70].m_dDX = 3.375000;
	m_ShotMap[70].m_dDY = 7.125000;

	m_ShotMap[71].m_Ship_LookX = 856;
	m_ShotMap[71].m_Ship_LookY = 1280;
	m_ShotMap[71].m_xFirst = 9;
	m_ShotMap[71].m_yFirst = 17;
	m_ShotMap[71].m_dDX = 3.875000;
	m_ShotMap[71].m_dDY = 6.875000;

	m_ShotMap[72].m_Ship_LookX = 856;
	m_ShotMap[72].m_Ship_LookY = 1280;
	m_ShotMap[72].m_xFirst = 10;
	m_ShotMap[72].m_yFirst = 16;
	m_ShotMap[72].m_dDX = 4.375000;
	m_ShotMap[72].m_dDY = 6.625000;

	m_ShotMap[73].m_Ship_LookX = 976;
	m_ShotMap[73].m_Ship_LookY = 1192;
	m_ShotMap[73].m_xFirst = 12;
	m_ShotMap[73].m_yFirst = 15;
	m_ShotMap[73].m_dDX = 4.875000;
	m_ShotMap[73].m_dDY = 6.250000;

	m_ShotMap[74].m_Ship_LookX = 1088;
	m_ShotMap[74].m_Ship_LookY = 1088;
	m_ShotMap[74].m_xFirst = 13;
	m_ShotMap[74].m_yFirst = 14;
	m_ShotMap[74].m_dDX = 5.250000;
	m_ShotMap[74].m_dDY = 5.875000;

	m_ShotMap[75].m_Ship_LookX = 1192;
	m_ShotMap[75].m_Ship_LookY = 976;
	m_ShotMap[75].m_xFirst = 14;
	m_ShotMap[75].m_yFirst = 13;
	m_ShotMap[75].m_dDX = 5.750000;
	m_ShotMap[75].m_dDY = 5.500000;

	m_ShotMap[76].m_Ship_LookX = 1192;
	m_ShotMap[76].m_Ship_LookY = 976;
	m_ShotMap[76].m_xFirst = 15;
	m_ShotMap[76].m_yFirst = 12;
	m_ShotMap[76].m_dDX = 6.125000;
	m_ShotMap[76].m_dDY = 5.000000;

	m_ShotMap[77].m_Ship_LookX = 1280;
	m_ShotMap[77].m_Ship_LookY = 856;
	m_ShotMap[77].m_xFirst = 16;
	m_ShotMap[77].m_yFirst = 11;
	m_ShotMap[77].m_dDX = 6.500000;
	m_ShotMap[77].m_dDY = 4.500000;

	m_ShotMap[78].m_Ship_LookX = 1360;
	m_ShotMap[78].m_Ship_LookY = 720;
	m_ShotMap[78].m_xFirst = 16;
	m_ShotMap[78].m_yFirst = 10;
	m_ShotMap[78].m_dDX = 6.750000;
	m_ShotMap[78].m_dDY = 4.000000;

	m_ShotMap[79].m_Ship_LookX = 1416;
	m_ShotMap[79].m_Ship_LookY = 584;
	m_ShotMap[79].m_xFirst = 17;
	m_ShotMap[79].m_yFirst = 8;
	m_ShotMap[79].m_dDX = 7.000000;
	m_ShotMap[79].m_dDY = 3.500000;

	m_ShotMap[80].m_Ship_LookX = 1416;
	m_ShotMap[80].m_Ship_LookY = 584;
	m_ShotMap[80].m_xFirst = 18;
	m_ShotMap[80].m_yFirst = 7;
	m_ShotMap[80].m_dDX = 7.250000;
	m_ShotMap[80].m_dDY = 3.000000;

	m_ShotMap[81].m_Ship_LookX = 1472;
	m_ShotMap[81].m_Ship_LookY = 440;
	m_ShotMap[81].m_xFirst = 18;
	m_ShotMap[81].m_yFirst = 6;
	m_ShotMap[81].m_dDX = 7.500000;
	m_ShotMap[81].m_dDY = 2.500000;

	m_ShotMap[82].m_Ship_LookX = 1504;
	m_ShotMap[82].m_Ship_LookY = 296;
	m_ShotMap[82].m_xFirst = 19;
	m_ShotMap[82].m_yFirst = 4;
	m_ShotMap[82].m_dDX = 7.625000;
	m_ShotMap[82].m_dDY = 1.875000;

	m_ShotMap[83].m_Ship_LookX = 1528;
	m_ShotMap[83].m_Ship_LookY = 152;
	m_ShotMap[83].m_xFirst = 19;
	m_ShotMap[83].m_yFirst = 3;
	m_ShotMap[83].m_dDX = 7.750000;
	m_ShotMap[83].m_dDY = 1.375000;

	m_ShotMap[84].m_Ship_LookX = 1528;
	m_ShotMap[84].m_Ship_LookY = 152;
	m_ShotMap[84].m_xFirst = 19;
	m_ShotMap[84].m_yFirst = 1;
	m_ShotMap[84].m_dDX = 7.875000;
	m_ShotMap[84].m_dDY = 0.750000;

	m_ShotMap[85].m_Ship_LookX = 1536;
	m_ShotMap[85].m_Ship_LookY = 0;
	m_ShotMap[85].m_xFirst = 19;
	m_ShotMap[85].m_yFirst = 0;
	m_ShotMap[85].m_dDX = 7.875000;
	m_ShotMap[85].m_dDY = 0.125000;

	m_ShotMap[86].m_Ship_LookX = 1536;
	m_ShotMap[86].m_Ship_LookY = 0;
	m_ShotMap[86].m_xFirst = 19;
	m_ShotMap[86].m_yFirst = -1;
	m_ShotMap[86].m_dDX = 7.875000;
	m_ShotMap[86].m_dDY = -0.375000;

	m_ShotMap[87].m_Ship_LookX = 1528;
	m_ShotMap[87].m_Ship_LookY = -152;
	m_ShotMap[87].m_xFirst = 19;
	m_ShotMap[87].m_yFirst = -3;
	m_ShotMap[87].m_dDX = 7.875000;
	m_ShotMap[87].m_dDY = -1.000000;

	m_ShotMap[88].m_Ship_LookX = 1504;
	m_ShotMap[88].m_Ship_LookY = -296;
	m_ShotMap[88].m_xFirst = 19;
	m_ShotMap[88].m_yFirst = -5;
	m_ShotMap[88].m_dDX = 7.750000;
	m_ShotMap[88].m_dDY = -1.625000;

	m_ShotMap[89].m_Ship_LookX = 1504;
	m_ShotMap[89].m_Ship_LookY = -296;
	m_ShotMap[89].m_xFirst = 19;
	m_ShotMap[89].m_yFirst = -6;
	m_ShotMap[89].m_dDX = 7.625000;
	m_ShotMap[89].m_dDY = -2.125000;

	m_ShotMap[90].m_Ship_LookX = 1472;
	m_ShotMap[90].m_Ship_LookY = -440;
	m_ShotMap[90].m_xFirst = 18;
	m_ShotMap[90].m_yFirst = -7;
	m_ShotMap[90].m_dDX = 7.500000;
	m_ShotMap[90].m_dDY = -2.750000;

	m_ShotMap[91].m_Ship_LookX = 1416;
	m_ShotMap[91].m_Ship_LookY = -584;
	m_ShotMap[91].m_xFirst = 18;
	m_ShotMap[91].m_yFirst = -9;
	m_ShotMap[91].m_dDX = 7.250000;
	m_ShotMap[91].m_dDY = -3.250000;

	m_ShotMap[92].m_Ship_LookX = 1360;
	m_ShotMap[92].m_Ship_LookY = -720;
	m_ShotMap[92].m_xFirst = 17;
	m_ShotMap[92].m_yFirst = -10;
	m_ShotMap[92].m_dDX = 7.000000;
	m_ShotMap[92].m_dDY = -3.750000;

	m_ShotMap[93].m_Ship_LookX = 1360;
	m_ShotMap[93].m_Ship_LookY = -720;
	m_ShotMap[93].m_xFirst = 16;
	m_ShotMap[93].m_yFirst = -11;
	m_ShotMap[93].m_dDX = 6.625000;
	m_ShotMap[93].m_dDY = -4.250000;

	m_ShotMap[94].m_Ship_LookX = 1280;
	m_ShotMap[94].m_Ship_LookY = -856;
	m_ShotMap[94].m_xFirst = 15;
	m_ShotMap[94].m_yFirst = -12;
	m_ShotMap[94].m_dDX = 6.375000;
	m_ShotMap[94].m_dDY = -4.750000;

	m_ShotMap[95].m_Ship_LookX = 1192;
	m_ShotMap[95].m_Ship_LookY = -976;
	m_ShotMap[95].m_xFirst = 15;
	m_ShotMap[95].m_yFirst = -14;
	m_ShotMap[95].m_dDX = 6.000000;
	m_ShotMap[95].m_dDY = -5.250000;

	m_ShotMap[96].m_Ship_LookX = 1088;
	m_ShotMap[96].m_Ship_LookY = -1088;
	m_ShotMap[96].m_xFirst = 14;
	m_ShotMap[96].m_yFirst = -15;
	m_ShotMap[96].m_dDX = 5.625000;
	m_ShotMap[96].m_dDY = -5.625000;

	m_ShotMap[97].m_Ship_LookX = 1088;
	m_ShotMap[97].m_Ship_LookY = -1088;
	m_ShotMap[97].m_xFirst = 12;
	m_ShotMap[97].m_yFirst = -15;
	m_ShotMap[97].m_dDX = 5.125000;
	m_ShotMap[97].m_dDY = -6.000000;

	m_ShotMap[98].m_Ship_LookX = 976;
	m_ShotMap[98].m_Ship_LookY = -1192;
	m_ShotMap[98].m_xFirst = 11;
	m_ShotMap[98].m_yFirst = -16;
	m_ShotMap[98].m_dDX = 4.750000;
	m_ShotMap[98].m_dDY = -6.375000;

	m_ShotMap[99].m_Ship_LookX = 856;
	m_ShotMap[99].m_Ship_LookY = -1280;
	m_ShotMap[99].m_xFirst = 10;
	m_ShotMap[99].m_yFirst = -17;
	m_ShotMap[99].m_dDX = 4.250000;
	m_ShotMap[99].m_dDY = -6.750000;

	m_ShotMap[100].m_Ship_LookX = 720;
	m_ShotMap[100].m_Ship_LookY = -1360;
	m_ShotMap[100].m_xFirst = 9;
	m_ShotMap[100].m_yFirst = -18;
	m_ShotMap[100].m_dDX = 3.750000;
	m_ShotMap[100].m_dDY = -7.000000;

	m_ShotMap[101].m_Ship_LookX = 720;
	m_ShotMap[101].m_Ship_LookY = -1360;
	m_ShotMap[101].m_xFirst = 7;
	m_ShotMap[101].m_yFirst = -19;
	m_ShotMap[101].m_dDX = 3.125000;
	m_ShotMap[101].m_dDY = -7.250000;

	m_ShotMap[102].m_Ship_LookX = 584;
	m_ShotMap[102].m_Ship_LookY = -1416;
	m_ShotMap[102].m_xFirst = 6;
	m_ShotMap[102].m_yFirst = -19;
	m_ShotMap[102].m_dDX = 2.625000;
	m_ShotMap[102].m_dDY = -7.500000;

	m_ShotMap[103].m_Ship_LookX = 440;
	m_ShotMap[103].m_Ship_LookY = -1472;
	m_ShotMap[103].m_xFirst = 5;
	m_ShotMap[103].m_yFirst = -20;
	m_ShotMap[103].m_dDX = 2.125000;
	m_ShotMap[103].m_dDY = -7.625000;

	m_ShotMap[104].m_Ship_LookX = 296;
	m_ShotMap[104].m_Ship_LookY = -1504;
	m_ShotMap[104].m_xFirst = 3;
	m_ShotMap[104].m_yFirst = -20;
	m_ShotMap[104].m_dDX = 1.500000;
	m_ShotMap[104].m_dDY = -7.875000;

	m_ShotMap[105].m_Ship_LookX = 296;
	m_ShotMap[105].m_Ship_LookY = -1504;
	m_ShotMap[105].m_xFirst = 2;
	m_ShotMap[105].m_yFirst = -20;
	m_ShotMap[105].m_dDX = 1.000000;
	m_ShotMap[105].m_dDY = -7.875000;

	m_ShotMap[106].m_Ship_LookX = 152;
	m_ShotMap[106].m_Ship_LookY = -1528;
	m_ShotMap[106].m_xFirst = 0;
	m_ShotMap[106].m_yFirst = -20;
	m_ShotMap[106].m_dDX = 0.375000;
	m_ShotMap[106].m_dDY = -8.000000;

	m_ShotMap[107].m_Ship_LookX = -152;
	m_ShotMap[107].m_Ship_LookY = -1528;
	m_ShotMap[107].m_xFirst = -1;
	m_ShotMap[107].m_yFirst = -20;
	m_ShotMap[107].m_dDX = -0.250000;
	m_ShotMap[107].m_dDY = -8.000000;

	m_ShotMap[108].m_Ship_LookX = -152;
	m_ShotMap[108].m_Ship_LookY = -1528;
	m_ShotMap[108].m_xFirst = -2;
	m_ShotMap[108].m_yFirst = -20;
	m_ShotMap[108].m_dDX = -0.750000;
	m_ShotMap[108].m_dDY = -7.875000;

	m_ShotMap[109].m_Ship_LookX = -296;
	m_ShotMap[109].m_Ship_LookY = -1504;
	m_ShotMap[109].m_xFirst = -4;
	m_ShotMap[109].m_yFirst = -20;
	m_ShotMap[109].m_dDX = -1.375000;
	m_ShotMap[109].m_dDY = -7.875000;

	m_ShotMap[110].m_Ship_LookX = -440;
	m_ShotMap[110].m_Ship_LookY = -1472;
	m_ShotMap[110].m_xFirst = -5;
	m_ShotMap[110].m_yFirst = -20;
	m_ShotMap[110].m_dDX = -2.000000;
	m_ShotMap[110].m_dDY = -7.750000;

	m_ShotMap[111].m_Ship_LookX = -584;
	m_ShotMap[111].m_Ship_LookY = -1416;
	m_ShotMap[111].m_xFirst = -7;
	m_ShotMap[111].m_yFirst = -20;
	m_ShotMap[111].m_dDX = -2.500000;
	m_ShotMap[111].m_dDY = -7.625000;

	m_ShotMap[112].m_Ship_LookX = -584;
	m_ShotMap[112].m_Ship_LookY = -1416;
	m_ShotMap[112].m_xFirst = -8;
	m_ShotMap[112].m_yFirst = -19;
	m_ShotMap[112].m_dDX = -3.125000;
	m_ShotMap[112].m_dDY = -7.375000;

	m_ShotMap[113].m_Ship_LookX = -720;
	m_ShotMap[113].m_Ship_LookY = -1360;
	m_ShotMap[113].m_xFirst = -10;
	m_ShotMap[113].m_yFirst = -18;
	m_ShotMap[113].m_dDX = -3.625000;
	m_ShotMap[113].m_dDY = -7.125000;

	m_ShotMap[114].m_Ship_LookX = -856;
	m_ShotMap[114].m_Ship_LookY = -1280;
	m_ShotMap[114].m_xFirst = -11;
	m_ShotMap[114].m_yFirst = -18;
	m_ShotMap[114].m_dDX = -4.125000;
	m_ShotMap[114].m_dDY = -6.875000;

	m_ShotMap[115].m_Ship_LookX = -976;
	m_ShotMap[115].m_Ship_LookY = -1192;
	m_ShotMap[115].m_xFirst = -12;
	m_ShotMap[115].m_yFirst = -17;
	m_ShotMap[115].m_dDX = -4.625000;
	m_ShotMap[115].m_dDY = -6.500000;

	m_ShotMap[116].m_Ship_LookX = -976;
	m_ShotMap[116].m_Ship_LookY = -1192;
	m_ShotMap[116].m_xFirst = -13;
	m_ShotMap[116].m_yFirst = -16;
	m_ShotMap[116].m_dDX = -5.125000;
	m_ShotMap[116].m_dDY = -6.125000;

	m_ShotMap[117].m_Ship_LookX = -1088;
	m_ShotMap[117].m_Ship_LookY = -1088;
	m_ShotMap[117].m_xFirst = -14;
	m_ShotMap[117].m_yFirst = -15;
	m_ShotMap[117].m_dDX = -5.500000;
	m_ShotMap[117].m_dDY = -5.750000;

	m_ShotMap[118].m_Ship_LookX = -1192;
	m_ShotMap[118].m_Ship_LookY = -976;
	m_ShotMap[118].m_xFirst = -15;
	m_ShotMap[118].m_yFirst = -14;
	m_ShotMap[118].m_dDX = -5.875000;
	m_ShotMap[118].m_dDY = -5.375000;

	m_ShotMap[119].m_Ship_LookX = -1280;
	m_ShotMap[119].m_Ship_LookY = -856;
	m_ShotMap[119].m_xFirst = -16;
	m_ShotMap[119].m_yFirst = -13;
	m_ShotMap[119].m_dDX = -6.250000;
	m_ShotMap[119].m_dDY = -4.875000;

	m_ShotMap[120].m_Ship_LookX = -1280;
	m_ShotMap[120].m_Ship_LookY = -856;
	m_ShotMap[120].m_xFirst = -17;
	m_ShotMap[120].m_yFirst = -12;
	m_ShotMap[120].m_dDX = -6.625000;
	m_ShotMap[120].m_dDY = -4.500000;

	m_ShotMap[121].m_Ship_LookX = -1360;
	m_ShotMap[121].m_Ship_LookY = -720;
	m_ShotMap[121].m_xFirst = -18;
	m_ShotMap[121].m_yFirst = -10;
	m_ShotMap[121].m_dDX = -7.000000;
	m_ShotMap[121].m_dDY = -4.000000;

	m_ShotMap[122].m_Ship_LookX = -1416;
	m_ShotMap[122].m_Ship_LookY = -584;
	m_ShotMap[122].m_xFirst = -19;
	m_ShotMap[122].m_yFirst = -9;
	m_ShotMap[122].m_dDX = -7.250000;
	m_ShotMap[122].m_dDY = -3.375000;

	m_ShotMap[123].m_Ship_LookX = -1472;
	m_ShotMap[123].m_Ship_LookY = -440;
	m_ShotMap[123].m_xFirst = -19;
	m_ShotMap[123].m_yFirst = -8;
	m_ShotMap[123].m_dDX = -7.375000;
	m_ShotMap[123].m_dDY = -2.875000;

	m_ShotMap[124].m_Ship_LookX = -1472;
	m_ShotMap[124].m_Ship_LookY = -440;
	m_ShotMap[124].m_xFirst = -20;
	m_ShotMap[124].m_yFirst = -6;
	m_ShotMap[124].m_dDX = -7.625000;
	m_ShotMap[124].m_dDY = -2.375000;

	m_ShotMap[125].m_Ship_LookX = -1504;
	m_ShotMap[125].m_Ship_LookY = -296;
	m_ShotMap[125].m_xFirst = -20;
	m_ShotMap[125].m_yFirst = -5;
	m_ShotMap[125].m_dDX = -7.750000;
	m_ShotMap[125].m_dDY = -1.750000;

	m_ShotMap[126].m_Ship_LookX = -1528;
	m_ShotMap[126].m_Ship_LookY = -152;
	m_ShotMap[126].m_xFirst = -20;
	m_ShotMap[126].m_yFirst = -4;
	m_ShotMap[126].m_dDX = -7.875000;
	m_ShotMap[126].m_dDY = -1.250000;

	m_ShotMap[127].m_Ship_LookX = -1536;
	m_ShotMap[127].m_Ship_LookY = 0;
	m_ShotMap[127].m_xFirst = -20;
	m_ShotMap[127].m_yFirst = -2;
	m_ShotMap[127].m_dDX = -8.000000;
	m_ShotMap[127].m_dDY = -0.625000;

	m_ShotMap[128].m_Ship_LookX = -1536;
	m_ShotMap[128].m_Ship_LookY = 0;
	m_ShotMap[128].m_xFirst = -20;
	m_ShotMap[128].m_yFirst = 0;
	m_ShotMap[128].m_dDX = -8.000000;
	m_ShotMap[128].m_dDY = 0.000000;

	m_ShotMap[129].m_Ship_LookX = -1536;
	m_ShotMap[129].m_Ship_LookY = 0;
	m_ShotMap[129].m_xFirst = -20;
	m_ShotMap[129].m_yFirst = 1;
	m_ShotMap[129].m_dDX = -8.000000;
	m_ShotMap[129].m_dDY = 0.500000;

	m_ShotMap[130].m_Ship_LookX = -1528;
	m_ShotMap[130].m_Ship_LookY = 152;
	m_ShotMap[130].m_xFirst = -20;
	m_ShotMap[130].m_yFirst = 2;
	m_ShotMap[130].m_dDX = -7.875000;
	m_ShotMap[130].m_dDY = 1.125000;

	m_ShotMap[131].m_Ship_LookX = -1504;
	m_ShotMap[131].m_Ship_LookY = 296;
	m_ShotMap[131].m_xFirst = -20;
	m_ShotMap[131].m_yFirst = 4;
	m_ShotMap[131].m_dDX = -7.750000;
	m_ShotMap[131].m_dDY = 1.750000;

	m_ShotMap[132].m_Ship_LookX = -1472;
	m_ShotMap[132].m_Ship_LookY = 440;
	m_ShotMap[132].m_xFirst = -20;
	m_ShotMap[132].m_yFirst = 5;
	m_ShotMap[132].m_dDX = -7.625000;
	m_ShotMap[132].m_dDY = 2.250000;

	m_ShotMap[133].m_Ship_LookX = -1472;
	m_ShotMap[133].m_Ship_LookY = 440;
	m_ShotMap[133].m_xFirst = -19;
	m_ShotMap[133].m_yFirst = 7;
	m_ShotMap[133].m_dDX = -7.375000;
	m_ShotMap[133].m_dDY = 2.875000;

	m_ShotMap[134].m_Ship_LookX = -1416;
	m_ShotMap[134].m_Ship_LookY = 584;
	m_ShotMap[134].m_xFirst = -19;
	m_ShotMap[134].m_yFirst = 8;
	m_ShotMap[134].m_dDX = -7.250000;
	m_ShotMap[134].m_dDY = 3.375000;

	m_ShotMap[135].m_Ship_LookX = -1360;
	m_ShotMap[135].m_Ship_LookY = 720;
	m_ShotMap[135].m_xFirst = -18;
	m_ShotMap[135].m_yFirst = 9;
	m_ShotMap[135].m_dDX = -7.000000;
	m_ShotMap[135].m_dDY = 3.875000;

	m_ShotMap[136].m_Ship_LookX = -1280;
	m_ShotMap[136].m_Ship_LookY = 856;
	m_ShotMap[136].m_xFirst = -17;
	m_ShotMap[136].m_yFirst = 10;
	m_ShotMap[136].m_dDX = -6.625000;
	m_ShotMap[136].m_dDY = 4.375000;

	m_ShotMap[137].m_Ship_LookX = -1280;
	m_ShotMap[137].m_Ship_LookY = 856;
	m_ShotMap[137].m_xFirst = -16;
	m_ShotMap[137].m_yFirst = 12;
	m_ShotMap[137].m_dDX = -6.250000;
	m_ShotMap[137].m_dDY = 4.875000;

	m_ShotMap[138].m_Ship_LookX = -1192;
	m_ShotMap[138].m_Ship_LookY = 976;
	m_ShotMap[138].m_xFirst = -15;
	m_ShotMap[138].m_yFirst = 13;
	m_ShotMap[138].m_dDX = -5.875000;
	m_ShotMap[138].m_dDY = 5.250000;

	m_ShotMap[139].m_Ship_LookX = -1088;
	m_ShotMap[139].m_Ship_LookY = 1088;
	m_ShotMap[139].m_xFirst = -14;
	m_ShotMap[139].m_yFirst = 14;
	m_ShotMap[139].m_dDX = -5.500000;
	m_ShotMap[139].m_dDY = 5.750000;

	m_ShotMap[140].m_Ship_LookX = -976;
	m_ShotMap[140].m_Ship_LookY = 1192;
	m_ShotMap[140].m_xFirst = -13;
	m_ShotMap[140].m_yFirst = 15;
	m_ShotMap[140].m_dDX = -5.125000;
	m_ShotMap[140].m_dDY = 6.125000;

	m_ShotMap[141].m_Ship_LookX = -976;
	m_ShotMap[141].m_Ship_LookY = 1192;
	m_ShotMap[141].m_xFirst = -12;
	m_ShotMap[141].m_yFirst = 16;
	m_ShotMap[141].m_dDX = -4.625000;
	m_ShotMap[141].m_dDY = 6.500000;

	m_ShotMap[142].m_Ship_LookX = -856;
	m_ShotMap[142].m_Ship_LookY = 1280;
	m_ShotMap[142].m_xFirst = -11;
	m_ShotMap[142].m_yFirst = 16;
	m_ShotMap[142].m_dDX = -4.125000;
	m_ShotMap[142].m_dDY = 6.750000;

	m_ShotMap[143].m_Ship_LookX = -720;
	m_ShotMap[143].m_Ship_LookY = 1360;
	m_ShotMap[143].m_xFirst = -10;
	m_ShotMap[143].m_yFirst = 17;
	m_ShotMap[143].m_dDX = -3.625000;
	m_ShotMap[143].m_dDY = 7.000000;

	m_ShotMap[144].m_Ship_LookX = -584;
	m_ShotMap[144].m_Ship_LookY = 1416;
	m_ShotMap[144].m_xFirst = -8;
	m_ShotMap[144].m_yFirst = 18;
	m_ShotMap[144].m_dDX = -3.125000;
	m_ShotMap[144].m_dDY = 7.250000;

	m_ShotMap[145].m_Ship_LookX = -584;
	m_ShotMap[145].m_Ship_LookY = 1416;
	m_ShotMap[145].m_xFirst = -7;
	m_ShotMap[145].m_yFirst = 18;
	m_ShotMap[145].m_dDX = -2.500000;
	m_ShotMap[145].m_dDY = 7.500000;

	m_ShotMap[146].m_Ship_LookX = -440;
	m_ShotMap[146].m_Ship_LookY = 1472;
	m_ShotMap[146].m_xFirst = -5;
	m_ShotMap[146].m_yFirst = 19;
	m_ShotMap[146].m_dDX = -2.000000;
	m_ShotMap[146].m_dDY = 7.625000;

	m_ShotMap[147].m_Ship_LookX = -296;
	m_ShotMap[147].m_Ship_LookY = 1504;
	m_ShotMap[147].m_xFirst = -4;
	m_ShotMap[147].m_yFirst = 19;
	m_ShotMap[147].m_dDX = -1.375000;
	m_ShotMap[147].m_dDY = 7.750000;

	m_ShotMap[148].m_Ship_LookX = -152;
	m_ShotMap[148].m_Ship_LookY = 1528;
	m_ShotMap[148].m_xFirst = -2;
	m_ShotMap[148].m_yFirst = 19;
	m_ShotMap[148].m_dDX = -0.750000;
	m_ShotMap[148].m_dDY = 7.875000;

	m_ShotMap[149].m_Ship_LookX = -152;
	m_ShotMap[149].m_Ship_LookY = 1528;
	m_ShotMap[149].m_xFirst = -1;
	m_ShotMap[149].m_yFirst = 19;
	m_ShotMap[149].m_dDX = -0.250000;
	m_ShotMap[149].m_dDY = 7.875000;

	m_ShotMap[150].m_Ship_LookX = 152;
	m_ShotMap[150].m_Ship_LookY = 1528;
	m_ShotMap[150].m_xFirst = 0;
	m_ShotMap[150].m_yFirst = 19;
	m_ShotMap[150].m_dDX = 0.375000;
	m_ShotMap[150].m_dDY = 7.875000;

	m_ShotMap[151].m_Ship_LookX = 296;
	m_ShotMap[151].m_Ship_LookY = 1504;
	m_ShotMap[151].m_xFirst = 2;
	m_ShotMap[151].m_yFirst = 19;
	m_ShotMap[151].m_dDX = 1.000000;
	m_ShotMap[151].m_dDY = 7.875000;

	m_ShotMap[152].m_Ship_LookX = 296;
	m_ShotMap[152].m_Ship_LookY = 1504;
	m_ShotMap[152].m_xFirst = 3;
	m_ShotMap[152].m_yFirst = 19;
	m_ShotMap[152].m_dDX = 1.500000;
	m_ShotMap[152].m_dDY = 7.750000;

	m_ShotMap[153].m_Ship_LookX = 440;
	m_ShotMap[153].m_Ship_LookY = 1472;
	m_ShotMap[153].m_xFirst = 5;
	m_ShotMap[153].m_yFirst = 19;
	m_ShotMap[153].m_dDX = 2.125000;
	m_ShotMap[153].m_dDY = 7.625000;

	m_ShotMap[154].m_Ship_LookX = 584;
	m_ShotMap[154].m_Ship_LookY = 1416;
	m_ShotMap[154].m_xFirst = 6;
	m_ShotMap[154].m_yFirst = 18;
	m_ShotMap[154].m_dDX = 2.625000;
	m_ShotMap[154].m_dDY = 7.500000;

	m_ShotMap[155].m_Ship_LookX = 720;
	m_ShotMap[155].m_Ship_LookY = 1360;
	m_ShotMap[155].m_xFirst = 7;
	m_ShotMap[155].m_yFirst = 18;
	m_ShotMap[155].m_dDX = 3.125000;
	m_ShotMap[155].m_dDY = 7.250000;

	m_ShotMap[156].m_Ship_LookX = 720;
	m_ShotMap[156].m_Ship_LookY = 1360;
	m_ShotMap[156].m_xFirst = 9;
	m_ShotMap[156].m_yFirst = 17;
	m_ShotMap[156].m_dDX = 3.750000;
	m_ShotMap[156].m_dDY = 7.000000;

	m_ShotMap[157].m_Ship_LookX = 856;
	m_ShotMap[157].m_Ship_LookY = 1280;
	m_ShotMap[157].m_xFirst = 10;
	m_ShotMap[157].m_yFirst = 16;
	m_ShotMap[157].m_dDX = 4.250000;
	m_ShotMap[157].m_dDY = 6.625000;

	m_ShotMap[158].m_Ship_LookX = 976;
	m_ShotMap[158].m_Ship_LookY = 1192;
	m_ShotMap[158].m_xFirst = 11;
	m_ShotMap[158].m_yFirst = 15;
	m_ShotMap[158].m_dDX = 4.750000;
	m_ShotMap[158].m_dDY = 6.375000;

	m_ShotMap[159].m_Ship_LookX = 1088;
	m_ShotMap[159].m_Ship_LookY = 1088;
	m_ShotMap[159].m_xFirst = 12;
	m_ShotMap[159].m_yFirst = 15;
	m_ShotMap[159].m_dDX = 5.125000;
	m_ShotMap[159].m_dDY = 6.000000;

	m_ShotMap[160].m_Ship_LookX = 1088;
	m_ShotMap[160].m_Ship_LookY = 1088;
	m_ShotMap[160].m_xFirst = 14;
	m_ShotMap[160].m_yFirst = 14;
	m_ShotMap[160].m_dDX = 5.625000;
	m_ShotMap[160].m_dDY = 5.625000;

	m_ShotMap[161].m_Ship_LookX = 1192;
	m_ShotMap[161].m_Ship_LookY = 976;
	m_ShotMap[161].m_xFirst = 15;
	m_ShotMap[161].m_yFirst = 12;
	m_ShotMap[161].m_dDX = 6.000000;
	m_ShotMap[161].m_dDY = 5.125000;

	m_ShotMap[162].m_Ship_LookX = 1280;
	m_ShotMap[162].m_Ship_LookY = 856;
	m_ShotMap[162].m_xFirst = 15;
	m_ShotMap[162].m_yFirst = 11;
	m_ShotMap[162].m_dDX = 6.375000;
	m_ShotMap[162].m_dDY = 4.750000;

	m_ShotMap[163].m_Ship_LookX = 1360;
	m_ShotMap[163].m_Ship_LookY = 720;
	m_ShotMap[163].m_xFirst = 16;
	m_ShotMap[163].m_yFirst = 10;
	m_ShotMap[163].m_dDX = 6.625000;
	m_ShotMap[163].m_dDY = 4.250000;

	m_ShotMap[164].m_Ship_LookX = 1360;
	m_ShotMap[164].m_Ship_LookY = 720;
	m_ShotMap[164].m_xFirst = 17;
	m_ShotMap[164].m_yFirst = 9;
	m_ShotMap[164].m_dDX = 7.000000;
	m_ShotMap[164].m_dDY = 3.750000;

	m_ShotMap[165].m_Ship_LookX = 1416;
	m_ShotMap[165].m_Ship_LookY = 584;
	m_ShotMap[165].m_xFirst = 18;
	m_ShotMap[165].m_yFirst = 7;
	m_ShotMap[165].m_dDX = 7.250000;
	m_ShotMap[165].m_dDY = 3.125000;

	m_ShotMap[166].m_Ship_LookX = 1472;
	m_ShotMap[166].m_Ship_LookY = 440;
	m_ShotMap[166].m_xFirst = 18;
	m_ShotMap[166].m_yFirst = 6;
	m_ShotMap[166].m_dDX = 7.500000;
	m_ShotMap[166].m_dDY = 2.625000;

	m_ShotMap[167].m_Ship_LookX = 1504;
	m_ShotMap[167].m_Ship_LookY = 296;
	m_ShotMap[167].m_xFirst = 19;
	m_ShotMap[167].m_yFirst = 5;
	m_ShotMap[167].m_dDX = 7.625000;
	m_ShotMap[167].m_dDY = 2.125000;

	m_ShotMap[168].m_Ship_LookX = 1504;
	m_ShotMap[168].m_Ship_LookY = 296;
	m_ShotMap[168].m_xFirst = 19;
	m_ShotMap[168].m_yFirst = 3;
	m_ShotMap[168].m_dDX = 7.750000;
	m_ShotMap[168].m_dDY = 1.500000;

	m_ShotMap[169].m_Ship_LookX = 1528;
	m_ShotMap[169].m_Ship_LookY = 152;
	m_ShotMap[169].m_xFirst = 19;
	m_ShotMap[169].m_yFirst = 2;
	m_ShotMap[169].m_dDX = 7.875000;
	m_ShotMap[169].m_dDY = 1.000000;

	m_ShotMap[170].m_Ship_LookX = 1536;
	m_ShotMap[170].m_Ship_LookY = 0;
	m_ShotMap[170].m_xFirst = 19;
	m_ShotMap[170].m_yFirst = 0;
	m_ShotMap[170].m_dDX = 7.875000;
	m_ShotMap[170].m_dDY = 0.375000;

	m_ShotMap[171].m_Ship_LookX = 1536;
	m_ShotMap[171].m_Ship_LookY = 0;
	m_ShotMap[171].m_xFirst = 19;
	m_ShotMap[171].m_yFirst = -1;
	m_ShotMap[171].m_dDX = 7.875000;
	m_ShotMap[171].m_dDY = -0.250000;

	m_ShotMap[172].m_Ship_LookX = 1528;
	m_ShotMap[172].m_Ship_LookY = -152;
	m_ShotMap[172].m_xFirst = 19;
	m_ShotMap[172].m_yFirst = -2;
	m_ShotMap[172].m_dDX = 7.875000;
	m_ShotMap[172].m_dDY = -0.750000;

	m_ShotMap[173].m_Ship_LookX = 1528;
	m_ShotMap[173].m_Ship_LookY = -152;
	m_ShotMap[173].m_xFirst = 19;
	m_ShotMap[173].m_yFirst = -4;
	m_ShotMap[173].m_dDX = 7.750000;
	m_ShotMap[173].m_dDY = -1.375000;

	m_ShotMap[174].m_Ship_LookX = 1504;
	m_ShotMap[174].m_Ship_LookY = -296;
	m_ShotMap[174].m_xFirst = 19;
	m_ShotMap[174].m_yFirst = -5;
	m_ShotMap[174].m_dDX = 7.625000;
	m_ShotMap[174].m_dDY = -2.000000;

	m_ShotMap[175].m_Ship_LookX = 1472;
	m_ShotMap[175].m_Ship_LookY = -440;
	m_ShotMap[175].m_xFirst = 18;
	m_ShotMap[175].m_yFirst = -7;
	m_ShotMap[175].m_dDX = 7.500000;
	m_ShotMap[175].m_dDY = -2.500000;

	m_ShotMap[176].m_Ship_LookX = 1416;
	m_ShotMap[176].m_Ship_LookY = -584;
	m_ShotMap[176].m_xFirst = 18;
	m_ShotMap[176].m_yFirst = -8;
	m_ShotMap[176].m_dDX = 7.250000;
	m_ShotMap[176].m_dDY = -3.125000;

	m_ShotMap[177].m_Ship_LookX = 1416;
	m_ShotMap[177].m_Ship_LookY = -584;
	m_ShotMap[177].m_xFirst = 17;
	m_ShotMap[177].m_yFirst = -10;
	m_ShotMap[177].m_dDX = 7.000000;
	m_ShotMap[177].m_dDY = -3.625000;

	m_ShotMap[178].m_Ship_LookX = 1360;
	m_ShotMap[178].m_Ship_LookY = -720;
	m_ShotMap[178].m_xFirst = 16;
	m_ShotMap[178].m_yFirst = -11;
	m_ShotMap[178].m_dDX = 6.750000;
	m_ShotMap[178].m_dDY = -4.125000;

	m_ShotMap[179].m_Ship_LookX = 1280;
	m_ShotMap[179].m_Ship_LookY = -856;
	m_ShotMap[179].m_xFirst = 16;
	m_ShotMap[179].m_yFirst = -12;
	m_ShotMap[179].m_dDX = 6.500000;
	m_ShotMap[179].m_dDY = -4.625000;

	m_ShotMap[180].m_Ship_LookX = 1192;
	m_ShotMap[180].m_Ship_LookY = -976;
	m_ShotMap[180].m_xFirst = 15;
	m_ShotMap[180].m_yFirst = -13;
	m_ShotMap[180].m_dDX = 6.125000;
	m_ShotMap[180].m_dDY = -5.125000;

	m_ShotMap[181].m_Ship_LookX = 1192;
	m_ShotMap[181].m_Ship_LookY = -976;
	m_ShotMap[181].m_xFirst = 14;
	m_ShotMap[181].m_yFirst = -14;
	m_ShotMap[181].m_dDX = 5.750000;
	m_ShotMap[181].m_dDY = -5.500000;

	m_ShotMap[182].m_Ship_LookX = 1088;
	m_ShotMap[182].m_Ship_LookY = -1088;
	m_ShotMap[182].m_xFirst = 13;
	m_ShotMap[182].m_yFirst = -15;
	m_ShotMap[182].m_dDX = 5.250000;
	m_ShotMap[182].m_dDY = -5.875000;

	m_ShotMap[183].m_Ship_LookX = 976;
	m_ShotMap[183].m_Ship_LookY = -1192;
	m_ShotMap[183].m_xFirst = 12;
	m_ShotMap[183].m_yFirst = -16;
	m_ShotMap[183].m_dDX = 4.875000;
	m_ShotMap[183].m_dDY = -6.250000;

	m_ShotMap[184].m_Ship_LookX = 856;
	m_ShotMap[184].m_Ship_LookY = -1280;
	m_ShotMap[184].m_xFirst = 10;
	m_ShotMap[184].m_yFirst = -17;
	m_ShotMap[184].m_dDX = 4.375000;
	m_ShotMap[184].m_dDY = -6.625000;

	m_ShotMap[185].m_Ship_LookX = 856;
	m_ShotMap[185].m_Ship_LookY = -1280;
	m_ShotMap[185].m_xFirst = 9;
	m_ShotMap[185].m_yFirst = -18;
	m_ShotMap[185].m_dDX = 3.875000;
	m_ShotMap[185].m_dDY = -7.000000;

	m_ShotMap[186].m_Ship_LookX = 720;
	m_ShotMap[186].m_Ship_LookY = -1360;
	m_ShotMap[186].m_xFirst = 8;
	m_ShotMap[186].m_yFirst = -19;
	m_ShotMap[186].m_dDX = 3.375000;
	m_ShotMap[186].m_dDY = -7.250000;

	m_ShotMap[187].m_Ship_LookX = 584;
	m_ShotMap[187].m_Ship_LookY = -1416;
	m_ShotMap[187].m_xFirst = 7;
	m_ShotMap[187].m_yFirst = -19;
	m_ShotMap[187].m_dDX = 2.875000;
	m_ShotMap[187].m_dDY = -7.375000;

	m_ShotMap[188].m_Ship_LookX = 440;
	m_ShotMap[188].m_Ship_LookY = -1472;
	m_ShotMap[188].m_xFirst = 5;
	m_ShotMap[188].m_yFirst = -20;
	m_ShotMap[188].m_dDX = 2.250000;
	m_ShotMap[188].m_dDY = -7.625000;

	m_ShotMap[189].m_Ship_LookX = 440;
	m_ShotMap[189].m_Ship_LookY = -1472;
	m_ShotMap[189].m_xFirst = 4;
	m_ShotMap[189].m_yFirst = -20;
	m_ShotMap[189].m_dDX = 1.750000;
	m_ShotMap[189].m_dDY = -7.750000;

	m_ShotMap[190].m_Ship_LookX = 296;
	m_ShotMap[190].m_Ship_LookY = -1504;
	m_ShotMap[190].m_xFirst = 2;
	m_ShotMap[190].m_yFirst = -20;
	m_ShotMap[190].m_dDX = 1.125000;
	m_ShotMap[190].m_dDY = -7.875000;

	m_ShotMap[191].m_Ship_LookX = 152;
	m_ShotMap[191].m_Ship_LookY = -1528;
	m_ShotMap[191].m_xFirst = 1;
	m_ShotMap[191].m_yFirst = -20;
	m_ShotMap[191].m_dDX = 0.500000;
	m_ShotMap[191].m_dDY = -8.000000;

	m_ShotMap[192].m_Ship_LookX = 0;
	m_ShotMap[192].m_Ship_LookY = -1536;
	m_ShotMap[192].m_xFirst = 0;
	m_ShotMap[192].m_yFirst = -20;
	m_ShotMap[192].m_dDX = 0.000000;
	m_ShotMap[192].m_dDY = -8.000000;

	m_ShotMap[193].m_Ship_LookX = -152;
	m_ShotMap[193].m_Ship_LookY = -1528;
	m_ShotMap[193].m_xFirst = -2;
	m_ShotMap[193].m_yFirst = -20;
	m_ShotMap[193].m_dDX = -0.625000;
	m_ShotMap[193].m_dDY = -8.000000;

	m_ShotMap[194].m_Ship_LookX = -296;
	m_ShotMap[194].m_Ship_LookY = -1504;
	m_ShotMap[194].m_xFirst = -4;
	m_ShotMap[194].m_yFirst = -20;
	m_ShotMap[194].m_dDX = -1.250000;
	m_ShotMap[194].m_dDY = -7.875000;

	m_ShotMap[195].m_Ship_LookX = -440;
	m_ShotMap[195].m_Ship_LookY = -1472;
	m_ShotMap[195].m_xFirst = -5;
	m_ShotMap[195].m_yFirst = -20;
	m_ShotMap[195].m_dDX = -1.750000;
	m_ShotMap[195].m_dDY = -7.750000;

	m_ShotMap[196].m_Ship_LookX = -440;
	m_ShotMap[196].m_Ship_LookY = -1472;
	m_ShotMap[196].m_xFirst = -6;
	m_ShotMap[196].m_yFirst = -20;
	m_ShotMap[196].m_dDX = -2.375000;
	m_ShotMap[196].m_dDY = -7.625000;

	m_ShotMap[197].m_Ship_LookX = -584;
	m_ShotMap[197].m_Ship_LookY = -1416;
	m_ShotMap[197].m_xFirst = -8;
	m_ShotMap[197].m_yFirst = -19;
	m_ShotMap[197].m_dDX = -2.875000;
	m_ShotMap[197].m_dDY = -7.375000;

	m_ShotMap[198].m_Ship_LookX = -720;
	m_ShotMap[198].m_Ship_LookY = -1360;
	m_ShotMap[198].m_xFirst = -9;
	m_ShotMap[198].m_yFirst = -19;
	m_ShotMap[198].m_dDX = -3.375000;
	m_ShotMap[198].m_dDY = -7.250000;

	m_ShotMap[199].m_Ship_LookX = -856;
	m_ShotMap[199].m_Ship_LookY = -1280;
	m_ShotMap[199].m_xFirst = -10;
	m_ShotMap[199].m_yFirst = -18;
	m_ShotMap[199].m_dDX = -4.000000;
	m_ShotMap[199].m_dDY = -7.000000;

	m_ShotMap[200].m_Ship_LookX = -856;
	m_ShotMap[200].m_Ship_LookY = -1280;
	m_ShotMap[200].m_xFirst = -12;
	m_ShotMap[200].m_yFirst = -17;
	m_ShotMap[200].m_dDX = -4.500000;
	m_ShotMap[200].m_dDY = -6.625000;

	m_ShotMap[201].m_Ship_LookX = -976;
	m_ShotMap[201].m_Ship_LookY = -1192;
	m_ShotMap[201].m_xFirst = -13;
	m_ShotMap[201].m_yFirst = -16;
	m_ShotMap[201].m_dDX = -4.875000;
	m_ShotMap[201].m_dDY = -6.250000;

	m_ShotMap[202].m_Ship_LookX = -1088;
	m_ShotMap[202].m_Ship_LookY = -1088;
	m_ShotMap[202].m_xFirst = -14;
	m_ShotMap[202].m_yFirst = -15;
	m_ShotMap[202].m_dDX = -5.375000;
	m_ShotMap[202].m_dDY = -5.875000;

	m_ShotMap[203].m_Ship_LookX = -1192;
	m_ShotMap[203].m_Ship_LookY = -976;
	m_ShotMap[203].m_xFirst = -15;
	m_ShotMap[203].m_yFirst = -14;
	m_ShotMap[203].m_dDX = -5.750000;
	m_ShotMap[203].m_dDY = -5.500000;

	m_ShotMap[204].m_Ship_LookX = -1192;
	m_ShotMap[204].m_Ship_LookY = -976;
	m_ShotMap[204].m_xFirst = -16;
	m_ShotMap[204].m_yFirst = -13;
	m_ShotMap[204].m_dDX = -6.125000;
	m_ShotMap[204].m_dDY = -5.125000;

	m_ShotMap[205].m_Ship_LookX = -1280;
	m_ShotMap[205].m_Ship_LookY = -856;
	m_ShotMap[205].m_xFirst = -17;
	m_ShotMap[205].m_yFirst = -12;
	m_ShotMap[205].m_dDX = -6.500000;
	m_ShotMap[205].m_dDY = -4.625000;

	m_ShotMap[206].m_Ship_LookX = -1360;
	m_ShotMap[206].m_Ship_LookY = -720;
	m_ShotMap[206].m_xFirst = -18;
	m_ShotMap[206].m_yFirst = -11;
	m_ShotMap[206].m_dDX = -6.875000;
	m_ShotMap[206].m_dDY = -4.125000;

	m_ShotMap[207].m_Ship_LookX = -1416;
	m_ShotMap[207].m_Ship_LookY = -584;
	m_ShotMap[207].m_xFirst = -18;
	m_ShotMap[207].m_yFirst = -10;
	m_ShotMap[207].m_dDX = -7.125000;
	m_ShotMap[207].m_dDY = -3.625000;

	m_ShotMap[208].m_Ship_LookX = -1416;
	m_ShotMap[208].m_Ship_LookY = -584;
	m_ShotMap[208].m_xFirst = -19;
	m_ShotMap[208].m_yFirst = -8;
	m_ShotMap[208].m_dDX = -7.375000;
	m_ShotMap[208].m_dDY = -3.125000;

	m_ShotMap[209].m_Ship_LookX = -1472;
	m_ShotMap[209].m_Ship_LookY = -440;
	m_ShotMap[209].m_xFirst = -20;
	m_ShotMap[209].m_yFirst = -7;
	m_ShotMap[209].m_dDX = -7.625000;
	m_ShotMap[209].m_dDY = -2.500000;

	m_ShotMap[210].m_Ship_LookX = -1504;
	m_ShotMap[210].m_Ship_LookY = -296;
	m_ShotMap[210].m_xFirst = -20;
	m_ShotMap[210].m_yFirst = -5;
	m_ShotMap[210].m_dDX = -7.750000;
	m_ShotMap[210].m_dDY = -2.000000;

	m_ShotMap[211].m_Ship_LookX = -1528;
	m_ShotMap[211].m_Ship_LookY = -152;
	m_ShotMap[211].m_xFirst = -20;
	m_ShotMap[211].m_yFirst = -4;
	m_ShotMap[211].m_dDX = -7.875000;
	m_ShotMap[211].m_dDY = -1.375000;

	m_ShotMap[212].m_Ship_LookX = -1528;
	m_ShotMap[212].m_Ship_LookY = -152;
	m_ShotMap[212].m_xFirst = -20;
	m_ShotMap[212].m_yFirst = -2;
	m_ShotMap[212].m_dDX = -7.875000;
	m_ShotMap[212].m_dDY = -0.750000;

	m_ShotMap[213].m_Ship_LookX = -1536;
	m_ShotMap[213].m_Ship_LookY = 0;
	m_ShotMap[213].m_xFirst = -20;
	m_ShotMap[213].m_yFirst = -1;
	m_ShotMap[213].m_dDX = -8.000000;
	m_ShotMap[213].m_dDY = -0.250000;

	m_ShotMap[214].m_Ship_LookX = -1536;
	m_ShotMap[214].m_Ship_LookY = 0;
	m_ShotMap[214].m_xFirst = -20;
	m_ShotMap[214].m_yFirst = 0;
	m_ShotMap[214].m_dDX = -8.000000;
	m_ShotMap[214].m_dDY = 0.375000;

	m_ShotMap[215].m_Ship_LookX = -1528;
	m_ShotMap[215].m_Ship_LookY = 152;
	m_ShotMap[215].m_xFirst = -20;
	m_ShotMap[215].m_yFirst = 2;
	m_ShotMap[215].m_dDX = -7.875000;
	m_ShotMap[215].m_dDY = 1.000000;

	m_ShotMap[216].m_Ship_LookX = -1504;
	m_ShotMap[216].m_Ship_LookY = 296;
	m_ShotMap[216].m_xFirst = -20;
	m_ShotMap[216].m_yFirst = 3;
	m_ShotMap[216].m_dDX = -7.875000;
	m_ShotMap[216].m_dDY = 1.500000;

	m_ShotMap[217].m_Ship_LookX = -1504;
	m_ShotMap[217].m_Ship_LookY = 296;
	m_ShotMap[217].m_xFirst = -20;
	m_ShotMap[217].m_yFirst = 5;
	m_ShotMap[217].m_dDX = -7.625000;
	m_ShotMap[217].m_dDY = 2.125000;

	m_ShotMap[218].m_Ship_LookX = -1472;
	m_ShotMap[218].m_Ship_LookY = 440;
	m_ShotMap[218].m_xFirst = -19;
	m_ShotMap[218].m_yFirst = 6;
	m_ShotMap[218].m_dDX = -7.500000;
	m_ShotMap[218].m_dDY = 2.625000;

	m_ShotMap[219].m_Ship_LookX = -1416;
	m_ShotMap[219].m_Ship_LookY = 584;
	m_ShotMap[219].m_xFirst = -19;
	m_ShotMap[219].m_yFirst = 7;
	m_ShotMap[219].m_dDX = -7.250000;
	m_ShotMap[219].m_dDY = 3.125000;

	m_ShotMap[220].m_Ship_LookX = -1360;
	m_ShotMap[220].m_Ship_LookY = 720;
	m_ShotMap[220].m_xFirst = -18;
	m_ShotMap[220].m_yFirst = 9;
	m_ShotMap[220].m_dDX = -7.000000;
	m_ShotMap[220].m_dDY = 3.750000;

	m_ShotMap[221].m_Ship_LookX = -1360;
	m_ShotMap[221].m_Ship_LookY = 720;
	m_ShotMap[221].m_xFirst = -17;
	m_ShotMap[221].m_yFirst = 10;
	m_ShotMap[221].m_dDX = -6.750000;
	m_ShotMap[221].m_dDY = 4.250000;

	m_ShotMap[222].m_Ship_LookX = -1280;
	m_ShotMap[222].m_Ship_LookY = 856;
	m_ShotMap[222].m_xFirst = -16;
	m_ShotMap[222].m_yFirst = 11;
	m_ShotMap[222].m_dDX = -6.375000;
	m_ShotMap[222].m_dDY = 4.750000;

	m_ShotMap[223].m_Ship_LookX = -1192;
	m_ShotMap[223].m_Ship_LookY = 976;
	m_ShotMap[223].m_xFirst = -15;
	m_ShotMap[223].m_yFirst = 12;
	m_ShotMap[223].m_dDX = -6.000000;
	m_ShotMap[223].m_dDY = 5.125000;

	m_ShotMap[224].m_Ship_LookX = -1088;
	m_ShotMap[224].m_Ship_LookY = 1088;
	m_ShotMap[224].m_xFirst = -15;
	m_ShotMap[224].m_yFirst = 14;
	m_ShotMap[224].m_dDX = -5.625000;
	m_ShotMap[224].m_dDY = 5.625000;

	m_ShotMap[225].m_Ship_LookX = -1088;
	m_ShotMap[225].m_Ship_LookY = 1088;
	m_ShotMap[225].m_xFirst = -14;
	m_ShotMap[225].m_yFirst = 15;
	m_ShotMap[225].m_dDX = -5.250000;
	m_ShotMap[225].m_dDY = 6.000000;

	m_ShotMap[226].m_Ship_LookX = -976;
	m_ShotMap[226].m_Ship_LookY = 1192;
	m_ShotMap[226].m_xFirst = -12;
	m_ShotMap[226].m_yFirst = 15;
	m_ShotMap[226].m_dDX = -4.750000;
	m_ShotMap[226].m_dDY = 6.375000;

	m_ShotMap[227].m_Ship_LookX = -856;
	m_ShotMap[227].m_Ship_LookY = 1280;
	m_ShotMap[227].m_xFirst = -11;
	m_ShotMap[227].m_yFirst = 16;
	m_ShotMap[227].m_dDX = -4.250000;
	m_ShotMap[227].m_dDY = 6.625000;

	m_ShotMap[228].m_Ship_LookX = -720;
	m_ShotMap[228].m_Ship_LookY = 1360;
	m_ShotMap[228].m_xFirst = -10;
	m_ShotMap[228].m_yFirst = 17;
	m_ShotMap[228].m_dDX = -3.750000;
	m_ShotMap[228].m_dDY = 7.000000;

	m_ShotMap[229].m_Ship_LookX = -720;
	m_ShotMap[229].m_Ship_LookY = 1360;
	m_ShotMap[229].m_xFirst = -9;
	m_ShotMap[229].m_yFirst = 18;
	m_ShotMap[229].m_dDX = -3.250000;
	m_ShotMap[229].m_dDY = 7.250000;

	m_ShotMap[230].m_Ship_LookX = -584;
	m_ShotMap[230].m_Ship_LookY = 1416;
	m_ShotMap[230].m_xFirst = -7;
	m_ShotMap[230].m_yFirst = 18;
	m_ShotMap[230].m_dDX = -2.750000;
	m_ShotMap[230].m_dDY = 7.500000;

	m_ShotMap[231].m_Ship_LookX = -440;
	m_ShotMap[231].m_Ship_LookY = 1472;
	m_ShotMap[231].m_xFirst = -6;
	m_ShotMap[231].m_yFirst = 19;
	m_ShotMap[231].m_dDX = -2.125000;
	m_ShotMap[231].m_dDY = 7.625000;

	m_ShotMap[232].m_Ship_LookX = -296;
	m_ShotMap[232].m_Ship_LookY = 1504;
	m_ShotMap[232].m_xFirst = -5;
	m_ShotMap[232].m_yFirst = 19;
	m_ShotMap[232].m_dDX = -1.625000;
	m_ShotMap[232].m_dDY = 7.750000;

	m_ShotMap[233].m_Ship_LookX = -296;
	m_ShotMap[233].m_Ship_LookY = 1504;
	m_ShotMap[233].m_xFirst = -3;
	m_ShotMap[233].m_yFirst = 19;
	m_ShotMap[233].m_dDX = -1.000000;
	m_ShotMap[233].m_dDY = 7.875000;

	m_ShotMap[234].m_Ship_LookX = -152;
	m_ShotMap[234].m_Ship_LookY = 1528;
	m_ShotMap[234].m_xFirst = -1;
	m_ShotMap[234].m_yFirst = 19;
	m_ShotMap[234].m_dDX = -0.375000;
	m_ShotMap[234].m_dDY = 7.875000;

	m_ShotMap[235].m_Ship_LookX = 152;
	m_ShotMap[235].m_Ship_LookY = 1528;
	m_ShotMap[235].m_xFirst = 0;
	m_ShotMap[235].m_yFirst = 19;
	m_ShotMap[235].m_dDX = 0.125000;
	m_ShotMap[235].m_dDY = 7.875000;

	m_ShotMap[236].m_Ship_LookX = 152;
	m_ShotMap[236].m_Ship_LookY = 1528;
	m_ShotMap[236].m_xFirst = 1;
	m_ShotMap[236].m_yFirst = 19;
	m_ShotMap[236].m_dDX = 0.750000;
	m_ShotMap[236].m_dDY = 7.875000;

	m_ShotMap[237].m_Ship_LookX = 296;
	m_ShotMap[237].m_Ship_LookY = 1504;
	m_ShotMap[237].m_xFirst = 3;
	m_ShotMap[237].m_yFirst = 19;
	m_ShotMap[237].m_dDX = 1.375000;
	m_ShotMap[237].m_dDY = 7.750000;

	m_ShotMap[238].m_Ship_LookX = 440;
	m_ShotMap[238].m_Ship_LookY = 1472;
	m_ShotMap[238].m_xFirst = 4;
	m_ShotMap[238].m_yFirst = 19;
	m_ShotMap[238].m_dDX = 1.875000;
	m_ShotMap[238].m_dDY = 7.625000;

	m_ShotMap[239].m_Ship_LookX = 584;
	m_ShotMap[239].m_Ship_LookY = 1416;
	m_ShotMap[239].m_xFirst = 6;
	m_ShotMap[239].m_yFirst = 18;
	m_ShotMap[239].m_dDX = 2.500000;
	m_ShotMap[239].m_dDY = 7.500000;

	m_ShotMap[240].m_Ship_LookX = 584;
	m_ShotMap[240].m_Ship_LookY = 1416;
	m_ShotMap[240].m_xFirst = 7;
	m_ShotMap[240].m_yFirst = 18;
	m_ShotMap[240].m_dDX = 3.000000;
	m_ShotMap[240].m_dDY = 7.250000;

	m_ShotMap[241].m_Ship_LookX = 720;
	m_ShotMap[241].m_Ship_LookY = 1360;
	m_ShotMap[241].m_xFirst = 8;
	m_ShotMap[241].m_yFirst = 17;
	m_ShotMap[241].m_dDX = 3.500000;
	m_ShotMap[241].m_dDY = 7.000000;

	m_ShotMap[242].m_Ship_LookX = 856;
	m_ShotMap[242].m_Ship_LookY = 1280;
	m_ShotMap[242].m_xFirst = 10;
	m_ShotMap[242].m_yFirst = 16;
	m_ShotMap[242].m_dDX = 4.000000;
	m_ShotMap[242].m_dDY = 6.750000;

	m_ShotMap[243].m_Ship_LookX = 976;
	m_ShotMap[243].m_Ship_LookY = 1192;
	m_ShotMap[243].m_xFirst = 11;
	m_ShotMap[243].m_yFirst = 16;
	m_ShotMap[243].m_dDX = 4.500000;
	m_ShotMap[243].m_dDY = 6.500000;

	m_ShotMap[244].m_Ship_LookX = 976;
	m_ShotMap[244].m_Ship_LookY = 1192;
	m_ShotMap[244].m_xFirst = 12;
	m_ShotMap[244].m_yFirst = 15;
	m_ShotMap[244].m_dDX = 5.000000;
	m_ShotMap[244].m_dDY = 6.125000;

	m_ShotMap[245].m_Ship_LookX = 1088;
	m_ShotMap[245].m_Ship_LookY = 1088;
	m_ShotMap[245].m_xFirst = 13;
	m_ShotMap[245].m_yFirst = 14;
	m_ShotMap[245].m_dDX = 5.500000;
	m_ShotMap[245].m_dDY = 5.750000;

	m_ShotMap[246].m_Ship_LookX = 1192;
	m_ShotMap[246].m_Ship_LookY = 976;
	m_ShotMap[246].m_xFirst = 14;
	m_ShotMap[246].m_yFirst = 13;
	m_ShotMap[246].m_dDX = 5.875000;
	m_ShotMap[246].m_dDY = 5.250000;

	m_ShotMap[247].m_Ship_LookX = 1280;
	m_ShotMap[247].m_Ship_LookY = 856;
	m_ShotMap[247].m_xFirst = 15;
	m_ShotMap[247].m_yFirst = 12;
	m_ShotMap[247].m_dDX = 6.250000;
	m_ShotMap[247].m_dDY = 4.875000;

	m_ShotMap[248].m_Ship_LookX = 1280;
	m_ShotMap[248].m_Ship_LookY = 856;
	m_ShotMap[248].m_xFirst = 16;
	m_ShotMap[248].m_yFirst = 10;
	m_ShotMap[248].m_dDX = 6.625000;
	m_ShotMap[248].m_dDY = 4.375000;

	m_ShotMap[249].m_Ship_LookX = 1360;
	m_ShotMap[249].m_Ship_LookY = 720;
	m_ShotMap[249].m_xFirst = 17;
	m_ShotMap[249].m_yFirst = 9;
	m_ShotMap[249].m_dDX = 6.875000;
	m_ShotMap[249].m_dDY = 3.875000;

	m_ShotMap[250].m_Ship_LookX = 1416;
	m_ShotMap[250].m_Ship_LookY = 584;
	m_ShotMap[250].m_xFirst = 17;
	m_ShotMap[250].m_yFirst = 8;
	m_ShotMap[250].m_dDX = 7.125000;
	m_ShotMap[250].m_dDY = 3.375000;

	m_ShotMap[251].m_Ship_LookX = 1472;
	m_ShotMap[251].m_Ship_LookY = 440;
	m_ShotMap[251].m_xFirst = 18;
	m_ShotMap[251].m_yFirst = 7;
	m_ShotMap[251].m_dDX = 7.375000;
	m_ShotMap[251].m_dDY = 2.875000;

	m_ShotMap[252].m_Ship_LookX = 1472;
	m_ShotMap[252].m_Ship_LookY = 440;
	m_ShotMap[252].m_xFirst = 19;
	m_ShotMap[252].m_yFirst = 5;
	m_ShotMap[252].m_dDX = 7.625000;
	m_ShotMap[252].m_dDY = 2.250000;

	m_ShotMap[253].m_Ship_LookX = 1504;
	m_ShotMap[253].m_Ship_LookY = 296;
	m_ShotMap[253].m_xFirst = 19;
	m_ShotMap[253].m_yFirst = 4;
	m_ShotMap[253].m_dDX = 7.750000;
	m_ShotMap[253].m_dDY = 1.750000;

	m_ShotMap[254].m_Ship_LookX = 1528;
	m_ShotMap[254].m_Ship_LookY = 152;
	m_ShotMap[254].m_xFirst = 19;
	m_ShotMap[254].m_yFirst = 2;
	m_ShotMap[254].m_dDX = 7.875000;
	m_ShotMap[254].m_dDY = 1.125000;

	m_ShotMap[255].m_Ship_LookX = 1536;
	m_ShotMap[255].m_Ship_LookY = 0;
	m_ShotMap[255].m_xFirst = 19;
	m_ShotMap[255].m_yFirst = 1;
	m_ShotMap[255].m_dDX = 7.875000;
	m_ShotMap[255].m_dDY = 0.500000;
}